---------------------------
-- lets simplify a bit..
---------------------------
local gf = Glance.Functions
local gv = Glance.Variables
local ga = Glance.Arrays
local gb = Glance.Buttons
local gm = Glance.Menus

---------------------------
-- create the main frame
---------------------------
function gf.loadFrame()
	Glance.Frames.topFrame = CreateFrame("BUTTON", "Glance", UIParent)
	local tf = Glance.Frames.topFrame
	tf:SetWidth(gv.screenWidth)
	tf:SetHeight(16)
	tf:SetPoint("TOPLEFT", 0, 0)
	tf:SetPoint("TOPRIGHT", 0, 0)
	
	local t = tf:CreateTexture(nil, "BACKGROUND")
	t:SetTexture(0, 0, 0, .5)
	t:SetAllPoints(tf)
	tf.texture = t 
	
	local t2 = tf:CreateTexture(nil, "BORDER")
	t2:SetTexture(.4, .4, .4)
	t2:SetPoint("TOPLEFT", tf, "BOTTOMLEFT", 0, 0)
	t2:SetPoint("TOPRIGHT", tf, "BOTTOMRIGHT", 0, 0)
	t2:SetWidth(gv.screenWidth)
	t2:SetHeight(1)
	
	local fs = tf:CreateFontString()
	fs:SetFont(gv.fnt_file, 12)
	tf:SetFontString(fs)
	tf:SetText("loading...")
	
	tf:RegisterForClicks("AnyUp")
	tf:SetScript("OnClick", function(self, button, down) if (button == "RightButton") then gf.Options.click(self, "LeftButton", down) end end)
	
	-- bottom frame
	-- Glance.Frames.bottomFrame = CreateFrame("BUTTON", "Glance", UIParent)
	-- local bf = Glance.Frames.bottomFrame
	-- bf:SetWidth(gv.screenWidth)
	-- bf:SetHeight(13)
	-- bf:SetPoint("BOTTOMLEFT", 0, 0)
	-- bf:SetPoint("BOTTOMRIGHT", 0, 0)
	
	-- local tx = bf:CreateTexture(nil, "BACKGROUND")
	-- tx:SetTexture(0, 0, 0, .5)
	-- tx:SetAllPoints(bf)
	-- bf.texture = tx 
	
	-- local tx2 = bf:CreateTexture(nil, "BORDER")
	-- tx2:SetTexture(.4, .4, .4)
	-- tx2:SetPoint("TOPLEFT", bf, "TOPLEFT", 0, 0)
	-- tx2:SetPoint("TOPRIGHT", bf, "TOPRIGHT", 0, 0)
	-- tx2:SetWidth(gv.screenWidth)
	-- tx2:SetHeight(1)
	
	-- local fx = bf:CreateFontString()
	-- fx:SetFont(gv.fnt_file, 11)
	-- bf:SetFontString(fx)
	-- bf:SetText("loading...")
	
	-- bf:RegisterForClicks("AnyUp")
	-- bf:SetScript("OnClick", function(self, button, down) if (button == "RightButton") then InterfaceOptionsFrame_OpenToCategory(panel1) end end)
	-- Glance.Debug("frame","create","mainFrames")
end

---------------------------
-- create button
---------------------------
function gf.createButton(anchor,i)
	local k = gv.button.order[anchor][i]
	local v = gb[k]
	if v.enabled then
		Glance.Debug("frame","create",k)
		v.button = CreateFrame("BUTTON", "Glance_Buttons_"..v.name, Glance.Frames.topFrame)
		local btn = v.button
		btn:SetHeight(16)
		local fs = btn:CreateFontString()
		if Glance_Local.Options.gameFont then
			local gameFontName,_,_ = GameFontNormal:GetFont()
			fs:SetFont(gameFontName, 12)
		else
			fs:SetFont(v.font, 12)
		end
		btn:SetFontString(fs)
		btn:SetText(v.text)
		if v.texture.normal ~= nil then
			btn:SetNormalTexture(v.texture.normal)
		end
		if v.texture.highlight ~= nil then
			btn:SetHighlightTexture(v.texture.highlight)
		end
		if v.update then
			for i=1, #v.events do
				--Glance.Events[v.name] = v.events[i]
				Glance.Debug("event","registered",v.events[i])
				btn:RegisterEvent(v.events[i])
			end
			btn:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4)
				for i=1, #v.events do
					if event == v.events[i] then
						Glance.Debug("event","fired",event)
						gf[k].update(self, event, arg1)
					end
				end
			end)
		end
		gm[k] = CreateFrame("Frame", "gm."..k)
		if v.tooltip then
			btn:SetScript("OnEnter", function(...) if v.enabled and v.tooltip then SetCursor("CAST_CURSOR") gf.showTooltip(v.name) end end)
			btn:SetScript("OnLeave", function(...) GameTooltip:Hide(); SetCursor("POINT_CURSOR"); gv.messageCheck = true; end)
		end
		btn:SetMovable(true)
		btn:ClearAllPoints()
		btn:RegisterForDrag("LeftButton")
		btn:RegisterForClicks("AnyUp")
		btn:SetScript("OnDragStart", function() gf.onDrag(btn) end)
		if v.click then
			btn:SetScript("OnClick", function(self, button, down) if button == "RightButton" then ToggleDropDownMenu(1, nil, gm[k], btn, 0, 0) GameTooltip:Hide() else if not btn.isMoving then gf[v.name].click(self, button, down) gv.buttonX,_ = GetCursorPosition() end end end)
		else
			btn:SetScript("OnClick", function(self, button, down) if button == "RightButton" then ToggleDropDownMenu(1, nil, gm[k], btn, 0, 0) GameTooltip:Hide() end end)
		end
		btn:SetScript("OnMouseDown", function(self, button, down) gv.buttonX,_ = GetCursorPosition() end)
		
		if v.texture.normal ~= nil then
			btn:SetWidth(16)
		else
			btn:SetWidth(btn:GetTextWidth())
		end
		
		btn:Hide()
	end
end

---------------------------
-- Disable Button
---------------------------
function gf.Disable(name)
	Glance.Debug("disable","button",name)
	DisableAddOn("Glance_"..name)
	if gb[name] ~= nil then
		gb[name].enabled = false
		for i=1, #gb[name].events do
			Glance.Debug("event","unregistered",gb[name].events[i])
			gb[name].button:UnregisterEvent(gb[name].events[i])
		end
		gb[name].button:Hide()
		gf.tableRemoveByVal(gv.button.order.LEFT, name)
		gf.tableRemoveByVal(gv.button.order.RIGHT, name)
		gf.positionButtons()
		Glance_Local.button.order.LEFT = gv.button.order.LEFT
		Glance_Local.button.order.RIGHT = gv.button.order.RIGHT
	end
end

---------------------------
-- Enable Button
---------------------------
function gf.Enable(name)
	Glance.Debug("enable","button",name)
	EnableAddOn("Glance_"..name)
	if IsAddOnLoaded("Glance_"..name) then
		if gb[name] ~= nil then
			gb[name].enabled = true
			if gb[name].button ~= nil then -- if loaded in memory
				for i=1, #gb[name].events do
					Glance.Debug("event","registered",gb[name].events[i])
					gb[name].button:RegisterEvent(gb[name].events[i])
				end
				table.insert(gv.button.order[gb[name].anchor],name)
			else -- if loaded from the UI/ACP
				gf.createButton(gb[name].anchor,#gv.button.order[gb[name].anchor])
				gf.load(name)
				if gb[name].update then
					gf[name].update()
				end
				if gb[name].onload then
					gf[name].onload()
				end
				if gb[name].options then
					gf[name].options()
				end
				gb[name].button:SetWidth(gb[name].button:GetTextWidth())
				gb.Options.save.perCharacter.Modules[name] = true
				gf.Options.resetModuleList()
			end
			gf.positionButtons()
			gb[name].button:Show()
		end
	else
		if IsAddOnLoadOnDemand("Glance_"..name) then -- if loaded from the Interface Options Panel.
			gv.loaded = false
			LoadAddOn("Glance_"..name)
			gf.createButton(gb[name].anchor,#gv.button.order[gb[name].anchor])
			gf.load(name)
			gv.loaded = true
			if gb[name].update then
				gf[name].update()
			end
			if gb[name].onload then
				gf[name].onload()
			end
			if gb[name].options then
				gf[name].options()
			end
			gb[name].button:SetWidth(gb[name].button:GetTextWidth())
			gf.positionButtons()
			gb[name].button:Show()
		end
	end
end

---------------------------
-- create popup menus
---------------------------
function gf.createMenu(btn)
	if gb[btn].menu then
		Glance.Debug("function","createMenu",btn)
		gm[btn].displayMode = "MENU"
		gm[btn].initialize = function(self, level)
			level = level or 1
			--if (level == 1) then 
				gf[btn].menu(level,UIDROPDOWNMENU_MENU_VALUE)
			--end
			--if (level == 2) then
			--	gf[btn].menu(level,UIDROPDOWNMENU_MENU_VALUE)
			--end
		end
	end
end

---------------------------
-- on drag
---------------------------
function gf.onDrag(btn)
	GameTooltip:Hide()
	if gv.flip then
		Glance.Debug("function","onDrag",btn:GetName())
		btn.isMoving = true
		local xpos,ypos = GetCursorPosition()
		for k, v in pairs(gb) do
			if btn:GetName() == gb[k].button:GetName() then
				if gv.buttonX-xpos > 0 then
					gf.flip(btn,"LEFT",gb[k].anchor)
				else
					gf.flip(btn,"RIGHT",gb[k].anchor)
				end
			end
		end
		btn:StopMovingOrSizing()
	end
end

---------------------------
-- swap buttons
---------------------------
function gf.flip(btn,dir,anchor)
	local i=0
	local bc = #gv.button.order[anchor]
	local bo = gv.button.order[anchor]
	print("button count: "..bc)
	for i=1, bc do
		local k = bo[i]
		local v = gb[k]
		print(gb[k])
		if btn == v.button then
			Glance.Debug("function flip",dir,v.name)
			if anchor == "LEFT" then
				if dir == "LEFT" then
					if i == 1 then
						return
					else
						bo[i-1],bo[i] = bo[i],bo[i-1]
					end
				else
					if i == bc then
						table.remove(gv.button.order.LEFT) 
						table.insert(gv.button.order.RIGHT,v.name)
						v.anchor = "RIGHT"
						v.position = #gv.button.order.RIGHT
					else 
						bo[i+1],bo[i] = bo[i],bo[i+1]
					end
				end
			else
				if dir == "LEFT" then
					if i == bc then
						table.remove(gv.button.order.RIGHT) 
						table.insert(gv.button.order.LEFT,v.name)
						v.anchor = "LEFT"
						v.position = #gv.button.order.LEFT
					else
						bo[i+1],bo[i] = bo[i],bo[i+1]
					end
				else
					if i == 1 then
						return
					else
						bo[i-1],bo[i] = bo[i],bo[i-1]
					end
				end
			end
			gf.positionButtons()
			break
		end
		btn:ClearAllPoints()
	end	
	btn.isMoving = false
	btn:StopMovingOrSizing()
	gv.flip = false
end

---------------------------
-- position buttons
---------------------------
function gf.positionButtons()
	Glance.Debug("function","positionButtons",nil)
	local i=0
	local prev = Glance.Frames.topFrame
	for i=1, #gv.button.order.LEFT do
		local k = gv.button.order.LEFT[i]
		local v = gb[k] or nil
		if v ~= nil then
			if v.enabled then
				if prev == Glance.Frames.topFrame then
					v.button:SetPoint("LEFT", prev, "LEFT", gv.spacer, 0)
				else
					v.button:SetPoint("LEFT", prev, "RIGHT", gv.spacer, 0)
				end
				prev = v.button
				v.anchor = "LEFT"
				v.position = i
			end
		end
	end
	i=0
	prev = Glance.Frames.topFrame
	for i=1, #gv.button.order.RIGHT do
		local k = gv.button.order.RIGHT[i]
		local v = gb[k] or nil
		if v ~= nil then
			if v.enabled then
				if prev == Glance.Frames.topFrame then
					v.button:SetPoint("RIGHT", prev, "RIGHT", -gv.spacer, 0)
				else
					v.button:SetPoint("RIGHT", prev, "LEFT", -gv.spacer, 0)
				end
				prev = v.button
				v.anchor = "RIGHT"
				v.position = i
			end
		end
	end
	gf.saveButtonOrder()
end

---------------------------
-- preferred button order
---------------------------
function gf.setPreferredOrder()
	Glance_Local.button.order = {
		["RIGHT"] = {
			"Options", -- [1]
			"Dungeons", -- [2]
			"DualSpec", -- [3]
			"Pets", -- [4]
			"Mounts", -- [5]
			"Clock", -- [6]
			"Location", -- [7]
		},
		["LEFT"] = {
			"Gold", -- [1]
			"Emblems", -- [2]
			"Friends", -- [3]
			"Guild", -- [4]
			"Armor", -- [5]
			"XP", -- [6]
			"Reputation", -- [7]
			"Professions", -- [8]
			"Latency", -- [9]
			"Framerate", -- [10]
			"Memory", -- [11]
			"Wintergrasp", -- [12]
			"TolBarad", -- [13]
		},
	}
end

---------------------------
-- update mods
---------------------------
function gf.updateAll()
	Glance.Debug("function","update","all")
	for k, v in pairs(gb) do
		if gb[k].enabled and gb[k].update then
			gf[k].update()
			gb[k].button:SetWidth(gb[k].button:GetTextWidth())
		end
	end
end

---------------------------
-- load variables
---------------------------
function gf.load(name)
	Glance.Debug("function","load variables",name)
	if gb[name].enabled then
		if gb[name].save.perAccount ~= nil then
			if Glance_Global[name] == nil then Glance_Global[name] = {} end
			for key, val in pairs(gb[name].save.perAccount) do
				if Glance_Global[name][key] == nil then 
					Glance_Global[name][key] = gb[name].save.perAccount[key]
				else
					gb[name].save.perAccount[key] = Glance_Global[name][key]
				end
			end
		end
		if gb[name].save.perCharacter ~= nil then
			if Glance_Local[name] == nil then Glance_Local[name] = {} end
			for key, val in pairs(gb[name].save.perCharacter) do
				if Glance_Local[name][key] == nil then 
					Glance_Local[name][key] = gb[name].save.perCharacter[key]
				else
					gb[name].save.perCharacter[key] = Glance_Local[name][key]
				end
			end
		end
		gf.createMenu(name)
	end
end

---------------------------
-- save variables
---------------------------
function gf.saveAll()
	Glance.Debug("function","save","all")
	for k, v in pairs(gb) do
		if gb[k].enabled then
			if gb[k].save.perAccount ~= nil then
				for key, val in pairs(gb[k].save.perAccount) do
					Glance_Global[k][key] = gb[k].save.perAccount[key]
				end
			end
			if gb[k].save.perCharacter ~= nil then
				for key, val in pairs(gb[k].save.perCharacter) do
					Glance_Local[k][key] = gb[k].save.perCharacter[key]
				end
			end
		end
	end
	gf.saveButtonOrder()
end

---------------------------
-- save buttons
---------------------------
function gf.saveButtonOrder()
	Glance_Local.button.order.LEFT = gv.button.order.LEFT
	Glance_Local.button.order.RIGHT = gv.button.order.RIGHT
end

---------------------------
-- move player/target/buffs/map
---------------------------
function gf.moveUI()
	local point, relativeTo, relativePoint, xOfs, yOfs
	if Glance_Local.Options.movePlayer then
		point, relativeTo, relativePoint, xOfs, yOfs = PlayerFrame:GetPoint(1)
		PlayerFrame:ClearAllPoints()
		PlayerFrame:SetPoint("TOPLEFT", Glance.Frames.topFrame, "BOTTOMLEFT", xOfs, yOfs)
		gv.hook.player = true
	elseif gv.hook.player then
		x = PlayerFrame:GetLeft() - UIParent:GetLeft()
		PlayerFrame:ClearAllPoints()
		PlayerFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, -4)
	end
	
	if Glance_Local.Options.moveTarget then
		point, relativeTo, relativePoint, xOfs, yOfs = TargetFrame:GetPoint(1)
		TargetFrame:ClearAllPoints();
		TargetFrame:SetPoint("TOPLEFT", Glance.Frames.topFrame, "BOTTOMLEFT", xOfs, yOfs)
		gv.hook.target = true
	elseif gv.hook.target then
		x = TargetFrame:GetLeft() - UIParent:GetLeft()
		TargetFrame:ClearAllPoints();
		TargetFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x, -4)
	end
	
	if Glance_Local.Options.moveBuffs then
		point, relativeTo, relativePoint, xOfs, yOfs = BuffFrame:GetPoint(1)
		BuffFrame:ClearAllPoints();
		BuffFrame:SetPoint("TOPRIGHT", Glance.Frames.topFrame, "BOTTOMRIGHT", xOfs, yOfs)
		gv.hook.buffs = true
	elseif gv.hook.buffs then
		x = BuffFrame:GetRight() - UIParent:GetRight()
		BuffFrame:ClearAllPoints();
		BuffFrame:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", x, -13)
	end
	
	if Glance_Local.Options.moveMinimap then
		point, relativeTo, relativePoint, xOfs, yOfs = MinimapCluster:GetPoint(1)
		MinimapCluster:ClearAllPoints();
		local yOfs2 = yOfs-5
		MinimapCluster:SetPoint("TOPRIGHT", Glance.Frames.topFrame, "BOTTOMRIGHT", xOfs, yOfs2)
		gv.hook.minimap = true
		--point, relativeTo, relativePoint, xOfs, yOfs = MainMenuBar:GetPoint(1)
	elseif gv.hook.minimap then
		x = MinimapCluster:GetRight() - UIParent:GetRight()
		MinimapCluster:ClearAllPoints();
		MinimapCluster:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", "RIGHT", 0)
	end
		--MainMenuBar:ClearAllPoints();
		--MainMenuBar:SetPoint("CENTER", Glance.Frames.bottomFrame, "CENTER", xOfs, 33)
end

---------------------------
-- re-move player/target
---------------------------
function gf.checkUI()
	local point, relativeTo, relativePoint, xOfs, yOfs
	Glance.Debug("ui","reset",nil)
	if Glance_Local.Options.movePlayer then
		point, relativeTo, relativePoint, xOfs, yOfs = PlayerFrame:GetPoint(1)
		PlayerFrame:ClearAllPoints()
		PlayerFrame:SetPoint("TOPLEFT", Glance.Frames.topFrame, "BOTTOMLEFT", xOfs, yOfs)
	end
	if Glance_Local.Options.moveTarget then
		point, relativeTo, relativePoint, xOfs, yOfs = TargetFrame:GetPoint(1)
		TargetFrame:ClearAllPoints();
		TargetFrame:SetPoint("TOPLEFT", Glance.Frames.topFrame, "BOTTOMLEFT", xOfs, yOfs)
	end
	gv.vehicleCheck = false;
end

---------------------------
-- onEvent/onUpdate handler
---------------------------
function gf.handleEvents()
	Glance.Frames.topFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4)
		if event=="ADDON_LOADED" and arg1 == "Glance" then
			Glance.Debug("event","fired",event)
			gf.addonLoaded()
		elseif (event == "PLAYER_ENTERING_WORLD") then
			Glance.Debug("event","fired",event)
			gf.checkUI()
		elseif (event == "PLAYER_REGEN_DISABLED") then
			local t = Glance.Frames.topFrame.texture
			t:SetTexture(.4, 0, 0, .5)
		elseif (event == "PLAYER_REGEN_ENABLED") then
			local t = Glance.Frames.topFrame.texture
			t:SetTexture(0, 0, 0, .5)
		elseif (event == "UNIT_ENTERING_VEHICLE" and arg1 == "player") then
			Glance.Debug("event","fired",event)
			gv.vehicleCheck = true
		elseif (event == "UNIT_EXITING_VEHICLE" and arg1 == "player") then
			Glance.Debug("event","fired",event)
			gv.vehicleCheck = true
		elseif (event == "CHAT_MSG_ADDON") then
			gf.addonResponse(arg1,arg2,arg3,arg4)
		elseif (event == "TIME_PLAYED_MSG") then
			gv.gametime.initTotal = time() - arg1
			gv.gametime.initLevel = time() - arg2
			if Glance_Local.Options.timePlayed and not gv.timePlayed then
				gf.sendMSG("Total Time Played: "..gf.formatTime(time() - gv.gametime.initTotal))
				gf.sendMSG("Time Played This Level: "..gf.formatTime(time() - gv.gametime.initLevel))
				gv.timePlayed = true
			end
		elseif (event == "PLAYER_LOGOUT") then
			Glance.Debug("event","fired",event)
			gf.saveAll()
		end
	end)
	Glance.Frames.topFrame:SetScript("OnUpdate", function(self, elapsed)
		for k, v in pairs(Glance.Timers) do 
			if Glance.Timers[k] ~= nil then --min,max,reset,button,func,var
				v[1] = v[1] + ceil(elapsed)
				if v[1] > v[2] then
					if v[5] ~= nil then
						if v[4] ~= nil then
							gf[v[4]][v[5]]()
						else
							gf[v[5]]()
						end
					end
					if v[6] ~= nil then
						gv[v[6]] = true
					end
					if v[3] then
						v[1] = 0
					else
						Glance.Timers[k] = nil
					end
				end
			end
		end
		gv.timer1 = gv.timer1 + elapsed
		if gv.timer1 >= 1 then
			gv.timer1 = 0
			gv.overflowFix = true
			for k, v in pairs(gb) do
				if gb[k].enabled and gb[k].timer1 then
					gf[k].update()
				end
				if gb[k].enabled and gb[k].timerTooltip then
					if GameTooltip:IsShown() and GameTooltip:GetOwner() == gb[k].button then
						gf.showTooltip(k)
					end
				end
			end
			if InCombatLockdown() ~= nil then
			else
			end
		end
		gv.timer5 = gv.timer5 + elapsed
		if gv.timer5 >= 5 then
			gv.timer5 = 0
			for k, v in pairs(gb) do
				if gb[k].enabled and gb[k].timer5 then
					gf[k].update()
				end
			end
			if gv.vehicleCheck then
				gf.checkUI()
			end
		end
	end)
end

---------------------------
-- addon loaded event
---------------------------
function gf.addonLoaded()
	Glance.Debug("function","addonLoaded",nil)
	Glance.Debug("loading","modules",nil)
	for i=1, GetNumAddOns() do
		local AddOnParent = GetAddOnDependencies(i)
		if AddOnParent == "Glance" then
			local name, title, notes, enabled = GetAddOnInfo(i)
			if name ~= "Glance_Options" and name ~= "Glance_Frames" then
				if Glance_Local.Options.Modules[title] == nil and enabled ~= nil then
					Glance_Local.Options.Modules[title] = true
				end
				if enabled == nil then
					Glance_Local.Options.Modules[title] = false
					if Glance_Local.button ~= nil then
						gf.tableRemoveByVal(Glance_Local.button.order.LEFT, title)
						gf.tableRemoveByVal(Glance_Local.button.order.RIGHT, title)
					end
				end
				if Glance_Local.Options.Modules[title] then
					local loaded, reason = LoadAddOn(i)
				end
			end
		end
	end
	for i=1, #gv.button.order.LEFT do
		gf.createButton("LEFT",i)
	end
	for i=1, #gv.button.order.RIGHT do
		gf.createButton("RIGHT",i)
	end
	gf.loadDefaultVariables()
	RegisterAddonMessagePrefix("Glance")
end

---------------------------
-- first run onload delay called from timers
---------------------------
function gf.onLoad()
	Glance.Debug("function","onLoad",nil)
	Glance.Frames.topFrame:SetScale(Glance_Local.Options.frameScale)
	if Glance_Local.button.order.RIGHT[1] == nil then
		gf.setPreferredOrder()
	end
	for k, v in pairs(gb) do
		gf.load(k,v)
		gf.tableAddByVal(Glance_Local.button.order[gb[k].anchor], k)
	end
	gv.button.order.LEFT = Glance_Local.button.order.LEFT
	gv.button.order.RIGHT = Glance_Local.button.order.RIGHT
	gv.loaded = true
	gf.updateAll()
	gf.positionButtons()
	for k, v in pairs(gb) do
		if gb[k].button ~= nil then
			gb[k].button:Show()
			if gb[k].onload then
				gf[k].onload()
			end
		end
	end
	Glance.Frames.topFrame:SetText("")
	gv.gametime.initSession = time()
	gv.requestingTimePlayed = true
	RequestTimePlayed()
	if Glance_Local.Options.movePlayer or Glance_Local.Options.moveTarget or Glance_Local.Options.moveBuffs or Glance_Local.Options.moveMinimap then
		gf.moveUI()
		--gf.setMinimap() -- FRAMES ADDON ONLY
	end
	gf.sendMSG("v"..GetAddOnMetadata("Glance","Version").." loaded.  Type '/glance options' to set your preferences.")

end

---------------------------
-- initialize
---------------------------
function gf.Initialize()
	Glance.Debug("function","initialize",nil)
	gf.loadFrame()
	Glance.Frames.topFrame:RegisterEvent("ADDON_LOADED")
	Glance.Frames.topFrame:RegisterEvent("TIME_PLAYED_MSG")
	Glance.Frames.topFrame:RegisterEvent("CHAT_MSG_ADDON")
	Glance.Frames.topFrame:RegisterEvent("PLAYER_LOGIN")
	Glance.Frames.topFrame:RegisterEvent("PLAYER_LOGOUT")
	Glance.Frames.topFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	Glance.Frames.topFrame:RegisterEvent("UNIT_ENTERING_VEHICLE")
	Glance.Frames.topFrame:RegisterEvent("UNIT_EXITING_VEHICLE")
	Glance.Frames.topFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Glance.Frames.topFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
	gf.handleEvents()
	Glance.Frames.topFrame:Show()
	--Glance.Frames.bottomFrame:Show()
end

---------------------------
-- slash commands
---------------------------
SLASH_Glance1 = "/Glance"
SlashCmdList["Glance"] = function (msg, editBox)
	if strfind(msg,"debug") ~= nil then
		if gv.Debug then
			gv.Debug = false
			gf.sendMSG("Debug Mode: off")
		else
			gv.Debug = true
			gf.sendMSG("Debug Mode: on")
		end
	else
		lmsg = string.lower(msg)
		if lmsg == "options" then
			 gf.Options.click("", "LeftButton", "")
		elseif lmsg == "hide" then
			Glance.Frames.topFrame:Hide()
			gf.moveUI()
			gf.sendMSG("Now hiding the Glance bar.")
		elseif lmsg == "show" then
			Glance.Frames.topFrame:Show()
			gf.moveUI()
			gf.sendMSG("Now showing the Glance bar.")
		elseif Glance.Commands[msg] ~= nil then
			Glance.Commands[msg].func()
		else
			local HEX = ga.colors.HEX
			gf.sendMSG(HEX.yellow.." ")
			gf.sendMSG(HEX.orange.."Glance Options")
			gf.sendMSG(HEX.yellow.."  /glance show: ")
			gf.sendMSG(HEX.white.."  Shows the bar")
			gf.sendMSG(HEX.yellow.."  /glance hide: ")
			gf.sendMSG(HEX.white.."  Hides the bar")
			gf.sendMSG(HEX.yellow.."  /glance options: ")
			gf.sendMSG(HEX.white.."  Shows the options panel")
			gf.sendMSG(HEX.white.." ")
			gf.sendMSG(HEX.orange.."Module Options (/glance)")
			for k, v in pairs(Glance.Commands) do
				gf.sendMSG(HEX.yellow.."  /glance "..k..": ")
				gf.sendMSG(HEX.white.."  "..v.desc)
			end
		end
	end
end
gf.Initialize()
