
---------------------------
-- create the button
---------------------------
Glance.Functions.AddButton("Options","RIGHT")
local btn = Glance.Buttons.Options
btn.text              = "      "
btn.enabled           = true
btn.texture.normal    = "Interface\\AddOns\\Glance\\images\\gear.tga"
btn.events            = {"ADDON_LOADED"}
btn.update            = true
btn.tooltip           = true
btn.click             = true
btn.onload            = true
btn.options           = true
btn.menu              = false
btn.save.perCharacter = {["Modules"] = {}}
btn.save.perAccount   = {}

---------------------------
-- variables
---------------------------
Glance.Arrays.Modules = {}
Glance.Variables.ModuleScrollIDX = 0

---------------------------
-- update
---------------------------
function Glance.Functions.Options.update(self, event, arg1)
	if event=="ADDON_LOADED" then
		local AddOnParent = GetAddOnDependencies(arg1)
		if AddOnParent == "Glance" then
			Glance.Functions.Options.resetModuleList()
		end
	end
end

---------------------------
-- tooltip
---------------------------
function Glance.Functions.Options.tooltip()
	Glance.Debug("function","tooltip","Options")
	local tooltip = Glance.Functions.Tooltip
	tooltip.Title("Options", "GLD")
	tooltip.Line("(Left-Click to open Glance Options)", "WHT")
end

---------------------------
-- click
---------------------------
function Glance.Functions.Options.click(self, button, down)
	Glance.Debug("function","click","Options")
	if button == "LeftButton" then
		if not IsAddOnLoaded("Glance_Options") then
			LoadAddOn("Glance_Options")
		end
		InterfaceOptionsFrame_OpenToCategory(Glance_Panel1)
	end
end

---------------------------
-- onload
---------------------------
function Glance.Functions.Options.onload()
	Glance.Functions.Options.resetModuleList()
end

---------------------------
-- options
---------------------------
function Glance.Functions.Options.options()
	Glance.Variables.ModuleScrollIDX = Glance.Functions.createScrollBar(_G["Glance_Panel3"],18,-70,345,378,20,Glance.Arrays.Modules,1,3,Glance.Functions.Options.setPreferredModule)
end

---------------------------
-- module scrollbar click
---------------------------
function Glance.Functions.Options.setPreferredModule(line)
	local pref, name, title
	--for line=1,20 do
		name = _G[getglobal("Glance_SBE"..Glance.Variables.ModuleScrollIDX..line):GetName().."Text"]:GetText()
		pref = _G["Glance_SBE"..Glance.Variables.ModuleScrollIDX..line]:GetChecked()
		for i=1, #Glance.Arrays.Modules do
			if Glance.Functions.matchSingle(name,Glance.Arrays.Modules[i][2]) then
				title = Glance.Arrays.Modules[i][2]
			end
		end
		if title ~= nil then
			if pref == 1 then
				pref = true
				Glance.Functions.Enable(title)
			else
				pref = false
				Glance.Functions.Disable(title)
			end
			Glance.Buttons.Options.save.perCharacter.Modules[title] = pref
		end
	--end
	Glance.Functions.Options.resetModuleList()
end

---------------------------
-- create modules array
---------------------------
function Glance.Functions.Options.resetModuleList()
	UpdateAddOnMemoryUsage()
	wipe(Glance.Arrays.Modules)
	for i=1, GetNumAddOns() do
		local AddOnParent = GetAddOnDependencies(i)
		if AddOnParent == "Glance" then
			local checked = false
			if IsAddOnLoaded(i) then
				checked = true
			end
			local name, title, notes, enabled = GetAddOnInfo(i)
			if enabled == nil then 
				checked = false 
			end
			if title ~= "Options" then
				local mem = Glance.Functions.Options.FormatMemory(GetAddOnMemoryUsage(i)) or "0"
				if Glance.Buttons.Options.save.perCharacter.Modules[title] == nil then
					Glance.Buttons.Options.save.perCharacter.Modules[title] = checked
				else
					checked = Glance.Buttons.Options.save.perCharacter.Modules[title]
				end
				table.insert(Glance.Arrays.Modules, {title.." Module ("..mem..")", title, checked})
				--table.sort(Glance.Arrays.Modules, function(a, b) return a[1] > b[1] end)
			end
		end
	end
end

---------------------------
-- format memory usage
---------------------------
function Glance.Functions.Options.FormatMemory(usage)
	local HEX = Glance.Arrays.colors.HEX
	if usage > 1000 then
		return format(HEX.red.."%.2f "..HEX.white.."mb", usage/1024)
	elseif usage > 500 then
		return format(HEX.yellow.."%.2f "..HEX.white.."kb", usage)
	elseif usage > 0 then
		return format(HEX.green.."%.2f "..HEX.white.."kb", usage)
	end
end